<?php

/**
 * Dynamic blocks module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

/**
 * Dynamic blocks management
 *
 * @package 	PG_RealEstate
 * @subpackage 	Dynamic blocks
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!function_exists('dynamic_blocks_area')) {

    /**
     * Return content of dynamic blocks area
     *
     * @param string $area_gid area guid
     *
     * @return string
     */
    function dynamic_blocks_area($area_gid)
    {
        $ci = &get_instance();
        $ci->load->model("Dynamic_blocks_model");

        return $ci->Dynamic_blocks_model->html_area_blocks_by_gid($area_gid);
    }

}

if (!function_exists('dynamic_blocks_html')) {

    /**
     * Return content of html dynamic block
     *
     * @param string $html html text
     *
     * @return string
     */
    function dynamic_blocks_html($html)
    {
        $ci = &get_instance();
        $ci->load->model('Dynamic_blocks_model');

        if (func_num_args() == 1 && is_array($html)) {
            $params = $html;
            $html = isset($params['html']) ? $params['html'] : '';
        }

        $ci->view->assign('block_html', $html);

        return $ci->view->fetch("helper_html_block", "user", "dynamic_blocks");
    }

}
