DROP TABLE IF EXISTS `[prefix]export`;
CREATE TABLE IF NOT EXISTS `[prefix]export` (
  `id` smallint(5) NOT NULL auto_increment,
  `gid_driver` varchar(50) NOT NULL,
  `id_object` smallint(5) NOT NULL,
  `name` varchar(100) NOT NULL,
  `relations` text NULL,
  `admin_form_data` text NULL,
  `output_type` enum('file', 'browser') NOT NULL,
  `file_format` varchar(100) NOT NULL,
  `append_date` tinyint(1) NOT NULL,
  `scheduler` varchar(150) NOT NULL,
  `published` tinyint(1) NOT NULL,
  `editable` tinyint(1) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `date_created` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `gid_driver` (`gid_driver`, `id_object`)  
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `[prefix]export_drivers`;
CREATE TABLE IF NOT EXISTS `[prefix]export_drivers` (
  `id` tinyint(3) NOT NULL auto_increment,
  `gid` varchar(50) NOT NULL,
  `link` varchar(100) NOT NULL,
  `settings` text NULL,
  `elements` text NULL,
  `editable` tinyint(1) NOT NULL,  
  `status` tinyint(1) NOT NULL,
  `date_created` datetime NOT NULL,
  `date_modified` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `gid` (`gid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `[prefix]export_modules`;
CREATE TABLE IF NOT EXISTS `[prefix]export_modules` (
  `id` smallint(5) NOT NULL auto_increment,
  `module` varchar(50) NOT NULL,
  `model` varchar(50) NOT NULL,
  `callback_get_fields` varchar(50) NOT NULL,
  `callback_get_admin_form` varchar(50) NOT NULL,
  `callback_get_user_form` varchar(50) NOT NULL,
  `callback_process_form` varchar(50) NOT NULL,
  `callback_export_data` varchar(50) NOT NULL,
  `sorter` tinyint(3) NOT NULL,
  `date_created` datetime NOT NULL,
  `date_modified` datetime NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
