<?php

namespace Pg\Modules\Field_editor\Models\Fields;

/**
 * Field editor module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

/**
 * Like field model
 *
 * @package 	PG_RealEstate
 * @subpackage 	FieldEditor
 *
 * @category	models
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Like_field_model
{

    /**
     * Field definition
     *
     * @var array
     */
    public $base_field_param = array(
        'type' => 'TINYINT',
        'constraint' => 3,
        'null' => false,
        'default' => 0,
    );

    /**
     * Default value configuration
     *
     * @var array
     */
    public $manage_field_param = array(
        'default_value' => array('type' => 'int', "default" => 0),
    );

    /**
     * Settings of form field
     *
     * @var array
     */
    public $form_field_settings = array();

    /**
     * Save field option (not available)
     *
     * @param array  $field      field settings
     * @param string $option_gid option guid
     * @param string $data       option data
     *
     * @return void
     */
    public function set_field_option($field, $option_gid, $data)
    {
        return;
    }

    /**
     * Remove field option (not available)
     *
     * @param array  $field      field settings
     * @param string $option_gid option guid
     *
     * @return void
     */
    public function delete_field_option($field, $option_gid)
    {
        return;
    }

    /**
     * Resort field options (not available)
     *
     * @param array $field       field settings
     * @param array $sorter_data sorting data
     *
     * @return void
     */
    public function sorter_field_option($field, $sorter_data)
    {
        return;
    }

}
