<?php

$module["module"] = "listings";
$module["install_name"] = "Listings";
$module["install_descr"] = "Listings for sale and buy";
$module["version"] = "5.03";
$module["files"] = array(
    array("file", "read", "application/modules/listings/controllers/admin_listings.php"),
    array("file", "read", "application/modules/listings/controllers/api_listings.php"),
    array("file", "read", "application/modules/listings/controllers/listings.php"),
    array("file", "read", "application/modules/listings/helpers/listings_helper.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_commercial_buy_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_commercial_lease_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_commercial_rent_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_commercial_sale_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_lot_and_land_buy_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_lot_and_land_lease_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_lot_and_land_rent_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_lot_and_land_sale_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_residential_buy_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_residential_lease_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_residential_rent_data.php"),
    array("file", "read", "application/modules/listings/install/listings_fields_residential_sale_data.php"),
    array("file", "read", "application/modules/listings/install/module.php"),
    array("file", "read", "application/modules/listings/install/" . PRODUCT_NAME . "/all/demo_content.php"),
    array("file", "read", "application/modules/listings/install/" . PRODUCT_NAME . "/all/modules_data.php"),
    array("file", "read", "application/modules/listings/install/" . PRODUCT_NAME . "/all/settings.php"),
    array("file", "read", "application/modules/listings/install/structure_deinstall.sql"),
    array("file", "read", "application/modules/listings/install/structure_install.sql"),
    array("file", "read", "application/modules/listings/js/listings-alert.js"),
    array("file", "read", "application/modules/listings/js/listings-calendar.js"),
    array("file", "read", "application/modules/listings/js/listings-edit-steps.js"),
    array("file", "read", "application/modules/listings/js/listings-email-alert.js"),
    array("file", "read", "application/modules/listings/js/listings-list.js"),
    array("file", "read", "application/modules/listings/js/listings-map.js"),
    array("file", "read", "application/modules/listings/js/listings-menu.js"),
    array("file", "read", "application/modules/listings/js/listings-order.js"),
    array("file", "read", "application/modules/listings/js/listings-print.js"),
    array("file", "read", "application/modules/listings/js/listings-saved.js"),
    array("file", "read", "application/modules/listings/js/listings-search.js"),
    array("file", "read", "application/modules/listings/js/listings-select.js"),
    array("file", "read", "application/modules/listings/js/listings-share.js"),
    array("file", "read", "application/modules/listings/js/mortgage-calc.js"),
    array("file", "read", "application/modules/listings/js/wish-list.js"),
    array("file", "read", "application/modules/listings/js/wish-lists-select.js"),
    array("file", "read", "application/modules/listings/models/listings_events_model.php"),
    array("file", "read", "application/modules/listings/models/listings_export_model.php"),
    array("file", "read", "application/modules/listings/models/listings_import_model.php"),
    array("file", "read", "application/modules/listings/models/listings_install_model.php"),
    array("file", "read", "application/modules/listings/models/listings_model.php"),
    array("file", "read", "application/modules/listings/models/listings_rss_model.php"),
    array("file", "read", "application/modules/listings/models/listings_search_model.php"),
    array("file", "read", "application/modules/listings/models/listings_stat_model.php"),
    array("file", "read", "application/modules/listings/models/listings_visitor_model.php"),
    array("file", "read", "application/modules/listings/models/saved_listings_model.php"),
    array("file", "read", "application/modules/listings/models/wish_list_model.php"),
    array("dir", "read", "application/modules/listings/langs"),
    // default data
    array("dir", "write", "uploads/file-uploads/listing-file"),
    array("dir", "write", "uploads/listing-photo"),
    array("dir", "write", "uploads/listing-photo/listings-photo"),
    array("dir", "write", "uploads/listing-search-photo"),
    array("dir", "write", "uploads/listing-slider-photo"),
    array("dir", "write", "uploads/video/listing-video"),
    array("dir", "write", "uploads/listing-vtour"),
    array("dir", "write", "uploads/listing-vtour/listings-vtour"),
    array("dir", "write", "uploads/listing-wish-list-photo"),
    array("dir", "write", "uploads/qr"),
    array("dir", "write", "temp/qrcode"),
);

$module["dependencies"] = array(
    "start" => array("version" => "1.01"),
    "menu" => array("version" => "1.01"),
    "countries" => array("version" => "2.02"),
    "field_editor" => array("version" => "1.03"),
    "file_uploads" => array("version" => "1.02"),
    "video_uploads" => array("version" => "1.02"),
    "upload_gallery" => array("version" => "2.01"),
    "properties" => array("version" => "1.02"),
    "uploads" => array("version" => "1.04"),
);

$module["linked_modules"] = array(
    "install" => array(
        "menu" => "install_menu",
        "subscriptions" => "install_subscriptions",
        "moderators" => "install_moderators",
        "field_editor" => "install_field_editor",
        "services" => "install_services",
        "dynamic_blocks" => "install_dynamic_blocks",
        "dynamic_blocks;services" => "install_dynamic_blocks_services",
        "uploads" => "install_uploads",
        "upload_gallery" => "install_upload_gallery",
        "video_uploads" => "install_video_uploads",
        "file_uploads" => "install_file_uploads",
        "export" => "install_export",
        "import" => "install_import",
        "site_map" => "install_site_map",
        "geomap" => "install_geomap",
        "reviews" => "install_reviews",
        "spam" => "install_spam",
        "banners" => "install_banners",
        "social_networking" => "install_social_networking",
        "cronjob" => "install_cronjob",
        "cronjob;services" => "install_cronjob_services",
        "notifications;services" => "install_notifications_services",
        "menu;users_private" => "install_users_private_menu",
        "moderation" => "install_moderation",
        "moderation;menu" => "install_moderation_menu",
    ),
    "deinstall" => array(
        "menu" => "deinstall_menu",
        "subscriptions" => "deinstall_subscriptions",
        "moderators" => "deinstall_moderators",
        "field_editor" => "deinstall_field_editor",
        "services" => "deinstall_services",
        "dynamic_blocks" => "deinstall_dynamic_blocks",
        "dynamic_blocks;services" => "deinstall_dynamic_blocks_services",
        "uploads" => "deinstall_uploads",
        "upload_gallery" => "deinstall_upload_gallery",
        "video_uploads" => "deinstall_video_uploads",
        "file_uploads" => "deinstall_file_uploads",
        "export" => "deinstall_export",
        "import" => "deinstall_import",
        "site_map" => "deinstall_site_map",
        "geomap" => "deinstall_geomap",
        "reviews" => "deinstall_reviews",
        "spam" => "deinstall_spam",
        "banners" => "deinstall_banners",
        "social_networking" => "deinstall_social_networking",
        "cronjob" => "deinstall_cronjob",
        "cronjob;services" => "deinstall_cronjob_services",
        "notifications;services" => "deinstall_notifications_services",
        "menu;users_private" => "deinstall_users_private_menu",
        "moderation" => "deinstall_moderation",
        "moderation;menu" => "deinstall_moderation_menu",
    )
);

if (!$_ENV['TRIAL_MODE']) {
    $module["files"][] = array("dir", "write", "uploads/file-uploads/listing-file/1");
    $module["files"][] = array("dir", "write", "uploads/file-uploads/listing-file/2");
    $module["files"][] = array("dir", "write", "uploads/file-uploads/listing-file/6");
    $module["files"][] = array("dir", "write", "uploads/file-uploads/listing-file/7");
    $module["files"][] = array("dir", "write", "uploads/file-uploads/listing-file/10");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/1");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/2");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/3");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/4");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/5");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/6");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/7");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/8");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/9");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/10");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/51");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/52");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/53");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/54");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/55");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/56");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/57");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/58");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/59");
    $module["files"][] = array("dir", "write", "uploads/listing-photo/listings-photo/60");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/1");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/2");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/3");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/4");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/5");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/6");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/7");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/8");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/9");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/10");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/51");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/52");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/53");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/54");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/55");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/56");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/57");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/58");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/59");
    $module["files"][] = array("dir", "write", "uploads/listing-search-photo/60");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/1");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/2");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/3");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/4");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/5");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/6");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/7");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/8");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/9");
    $module["files"][] = array("dir", "write", "uploads/listing-slider-photo/10");
    $module["files"][] = array("dir", "write", "uploads/video/listing-video/1");
    $module["files"][] = array("dir", "write", "uploads/video/listing-video/2");
    $module["files"][] = array("dir", "write", "uploads/video/listing-video/6");
    $module["files"][] = array("dir", "write", "uploads/video/listing-video/7");
    $module["files"][] = array("dir", "write", "uploads/video/listing-video/10");
    $module["files"][] = array("dir", "write", "uploads/listing-vtour/listings-vtour/4");
    $module["files"][] = array("dir", "write", "uploads/listing-vtour/listings-vtour/7");
    $module["files"][] = array("dir", "write", "uploads/listing-wish-list-photo/1");
    $module["files"][] = array("dir", "write", "uploads/listing-wish-list-photo/2");
    $module["files"][] = array("dir", "write", "uploads/listing-wish-list-photo/3");
    $module["files"][] = array("dir", "write", "uploads/listing-wish-list-photo/4");
}

$module['libraries'] = array(
    'Rssfeed', 'dompdf', 'Translit', 'qrcode', 'mobile_detect',
);
