function listingsList(optionArr) {
    this.properties = {
        siteUrl: '',
        listAjaxUrl: 'listings/ajax_index',
        operationType: null,
        order: null,
        orderDirection: null,
        page: 1,
        useRss: false,
        rssAjaxUrl: 'listings/ajax_get_rss_link',
        rssId: 'rss_link',
        savedListView: false,
        listBlockId: 'listings_block',
        sectionId: 'user_listing_sections',
        sectionsControlClass: 'js_search_listings_sections',
        sFormId: 'listings_search',
        errorObj: new Errors(),
        tIds: []
    };

    this.keyword_change_wait = 0;

    var _self = this;

    this.Init = function (options) {
        _self.properties = $.extend(_self.properties, options);
        _self.init_links();
        _self.init_form();
    };

    this.init_links = function () {
        if (_self.properties.operationType) {
            $('.' + _self.properties.sectionsControlClass).bind('change', function() {
                _self.properties.operationType = $(this).val();
                _self.properties.page = 1;
                _self.loading_block();
                history.pushState('', '', $('.' + _self.properties.sectionsControlClass).find(
                                    'option[value="'+$(this).val()+'"]').attr('href'));
                return false;
            });
            $('#' + _self.properties.sectionId + ' li').bind('click', function () {
                var id = $(this).attr('id');
                $('#' + _self.properties.sectionId + ' li').removeClass('active');
                $('#' + id).addClass('active');
                _self.properties.operationType = $('#' + id).attr('sgid');
                _self.properties.page = 1;
                _self.loading_block();
                window.history.pushState('', '', $(this).find('a').attr('href'));
                return false;
            });
        }

        if (_self.properties.useRss) {
            $('#' + _self.properties.rssId).bind('click', function () {
                $.get(_self.properties.siteUrl + _self.properties.rssAjaxUrl, {}, function (data) {
                    window.location.href = data;
                });
                return false;
            });
        }

        if (_self.properties.tIds.length) {
            for (var index in _self.properties.tIds) {
                var id = _self.properties.tIds[index];
                $(document).on('change', '#' + id + ' select', function () {
                    _self.properties.order = $(this).val();
                    _self.loading_block();
                    return false;
                });
                $(document).on('click', '#' + id + ' [name=sorter_btn]', function () {
                    if (_self.properties.orderDirection === 'ASC') {
                        _self.properties.orderDirection = 'DESC';
                        $(this).find('ins').removeClass('fa-arrow-up').addClass('fa-arrow-down');
                    } else {
                        _self.properties.orderDirection = 'ASC';
                        $(this).find('ins').removeClass('fa-arrow-down').addClass('fa-arrow-up');

                    }
                    _self.loading_block();
                    return false;
                });
                $(document).on('click', '#' + id + '>.pages a[data-page]', function () {
                    _self.properties.page = $(this).attr('data-page');
                    _self.loading_block();
                    return false;
                });
            }
        }
    };

    this.init_form = function () {
        $('#' + _self.properties.sFormId).bind('keyup', function () {
            _self.keyword_change_wait++;
            setTimeout(_self.check_search, 1000);
            return false;
        });
    };

    this.check_search = function () {
        _self.keyword_change_wait--;
        if (_self.keyword_change_wait) {
            return;
        }
        var data = $('#' + _self.properties.sFormId).serialize();
        _self.search(data);
    };

    this.search = function (data) {
        var url = _self.properties.siteUrl + _self.properties.listAjaxUrl + '/' +
                _self.properties.operationType + '/' + _self.properties.order + '/' +
                _self.properties.orderDirection + '/' + _self.properties.page;
        $.ajax({
            url: url,
            type: 'POST',
            cache: false,
            data: data,
            success: function (data) {
                $('#' + _self.properties.listBlockId).html(data);
            }
        });
    };

    this.loading_block = function (url) {
        if (!url) {
            url = _self.properties.siteUrl + _self.properties.listAjaxUrl + '/';
            if (_self.properties.operationType) {
                url += _self.properties.operationType + '/';
            }
            if (_self.properties.order) {
                url += _self.properties.order + '/';
            }
            if (_self.properties.orderDirection) {
                url += _self.properties.orderDirection + '/';
            }
            url += _self.properties.page;
        }

        var randNumber = Math.round(Math.random(1000) * 1000);
        $('#' + _self.properties.listBlockId).append('<div id="search_load_content' + randNumber + '" class="ajax_search"></div>');

        var randNumberMap = Math.round(Math.random(1000) * 1000);
        $('#listings_mini_map').append('<div id="search_load_content' + randNumberMap + '" class="ajax_search"></div>');

        $.ajax({
            url: url,
            type: 'GET',
            cache: false,
            success: function (data) {
                $('#' + _self.properties.listBlockId).html(data);
                if('undefined' !== typeof listings_search_obj) {
//                    window.listings_search_obj.runPageScroll(-100);
                }
            },
            complete: function () {
                $('#search_load_content' + randNumber).remove();
                $('#search_load_content' + randNumberMap).remove();
            }
        });
    };

    this.loading_post_block = function (post_data, url) {
        if (!url) {
            url = _self.properties.siteUrl + _self.properties.listAjaxUrl;
        }

        var randNumber = Math.round(Math.random(1000) * 1000);
        $('#' + _self.properties.listBlockId).append('<div id="search_load_content' + randNumber + '" class="ajax_search"></div>');

        var randNumberMap = Math.round(Math.random(1000) * 1000);
        $('#listings_mini_map').append('<div id="search_load_content' + randNumberMap + '" class="ajax_search"></div>');

        $.ajax({
            url: url,
            type: 'POST',
            data: post_data,
            cache: false,
            success: function (data) {
                $('#' + _self.properties.listBlockId).html(data);
            },
            complete: function () {
                $('#search_load_content' + randNumber).remove();
                $('#search_load_content' + randNumberMap).remove();
            }
        });
    };

    _self.Init(optionArr);
}
