function listingSearch(optionArr) {
    'use strict';

    this.properties = {
        siteUrl: '',
        viewAjaxUrl: 'listings/ajax_search/',
        loadQuickForm: 'listings/ajax_get_search_quick_form/',
        loadAdvancedForm: 'listings/ajax_get_search_advanced_form/',
        saveSearchUrl: 'listings/ajax_save_search/',
        resetQuickSearchFormUrl: 'listings/reset_quick_search/',
        sFromId: 'quick_search_form',
        rFromId: 'advanced_search_form',
        listBlockId: 'listings_block',
        mapBlockId: 'listings_map',
        saveBlockId: 'save_search_block',
        saveButtonClass: 'btn_save_search',
        saveSearchBlockClass: 'save-search-block',
        saveSearchDeleteFilterItem: 'save-search-delete-filter-item',
        saveSearchDeleteItem: 'save-search-delete-item',
        saveSearchUpdateUrl: 'listings/ajax_get_save_search_block/',
        quickFormId: 'quick_search_extend_form',
        advancedFormId: 'advanced_search_extend_form',
        sectionCl: 'js_search_listings_sections',
        deleteSearchUrl: 'listings/delete_saved_search',
        deleteSearchAjaxUrl: 'listings/ajax_delete_saved_search',
        resetSearchUrl: 'listings/ajax_reset_search_data',
        searchesBlockId: 'saved_searches_block',
        deleteFilterUrl: 'listings/delete_search_criteria',
        deleteFilterAjaxUrl: 'listings/ajax_delete_search_criteria',
        filtersBlockId: 'search_filter_block',
        resetSettingsBtnId: 'reset_settings_btn',
        viewMode: '',
        sFormRand: '',
        tIds: [],
        errorObj: new Errors()
    };

    var _self = this;

    this.Init = function (options) {
        _self.properties = $.extend(_self.properties, options);
        var sFormId = $('#' + _self.properties.sFromId);

        sFormId.bind('submit', function () {
            _self.search();
            closeFormToHide();
            return false;
        });

        sFormId.find('select[name=filters\\[type\\]]').bind('change', function () {
            var category = $('#' + _self.properties.sFromId).find('select[name=filters\\[category\\]]').val();
            _self.load_extend_form($(this).val(), category);
        });

        sFormId.find('select[name=filters\\[category\\]]').bind('change', function () {
            var type = $('#' + _self.properties.sFromId).find('select[name=filters\\[type\\]]').val();
            _self.load_extend_form(type, $(this).val());
        });

        $('#' + _self.properties.rFromId).bind('submit', function () {
            _self.refine();
            return false;
        });
        bindSaveSearch();
        $('#' + _self.properties.resetSettingsBtnId).bind('click', function () {
            $.ajax({
                url: _self.properties.siteUrl + _self.properties.resetSearchUrl,
                type: 'GET',
                success: function (newUrl) {
                    if ('string' === typeof newUrl && newUrl.length > 2) {
                        location.href = newUrl;
                    } else {
                        location.reload();
                    }
                }
            });
        });

        $(sFormId).on('change', '#operation_type' + _self.properties.sFormRand, function () {
            switch ($(this).val()) {
                case 'sale':
                    $('#with_photo_box' + _self.properties.sFormRand).show();
                    $('#booking_date_start' + _self.properties.sFormRand).hide();
                    $('#booking_date_end' + _self.properties.sFormRand).hide();
                    $('#booking_date_start-wrapper' + _self.properties.sFormRand).hide();
                    $('#booking_date_end-wrapper' + _self.properties.sFormRand).hide();
                    $('#booking_guests-wrapper' + _self.properties.sFormRand).hide();
                    $('#date_start' + _self.properties.sFormRand).val('');
                    $('#alt_date_start' + _self.properties.sFormRand).val('');
                    $('#date_end' + _self.properties.sFormRand).val('');
                    $('#alt_date_end' + _self.properties.sFormRand).val('');
                    $('#booking_guests' + _self.properties.sFormRand).hide().find('select').val('');
                    break;
                case 'buy':
                    $('#with_photo_box' + _self.properties.sFormRand).hide().find('input[type=checkbox]').prop('checked', false);
                    $('#booking_date_start' + _self.properties.sFormRand).hide();
                    $('#booking_date_end' + _self.properties.sFormRand).hide();
                    $('#booking_date_start-wrapper' + _self.properties.sFormRand).hide();
                    $('#booking_date_end-wrapper' + _self.properties.sFormRand).hide();
                    $('#booking_guests-wrapper' + _self.properties.sFormRand).hide();
                    $('#date_start' + _self.properties.sFormRand).val('');
                    $('#alt_date_start' + _self.properties.sFormRand).val('');
                    $('#date_end' + _self.properties.sFormRand).val('');
                    $('#alt_date_end' + _self.properties.sFormRand).val('');
                    $('#booking_guests' + _self.properties.sFormRand).hide().find('select').val('');
                    break;
                case 'rent':
                    $('#with_photo_box' + _self.properties.sFormRand).show();
                    $('#booking_date_start' + _self.properties.sFormRand).show();
                    $('#booking_date_end' + _self.properties.sFormRand).show();
                    $('#booking_guests' + _self.properties.sFormRand).show();
                    $('#booking_date_start-wrapper' + _self.properties.sFormRand).show();
                    $('#booking_date_end-wrapper' + _self.properties.sFormRand).show();
                    $('#booking_guests-wrapper' + _self.properties.sFormRand).show();
                    break;
                case 'lease':
                    $('#with_photo_box' + _self.properties.sFormRand).hide().find('input[type=checkbox]').prop('checked', false);
                    $('#booking_date_start' + _self.properties.sFormRand).show();
                    $('#booking_date_end' + _self.properties.sFormRand).show();
                    $('#booking_guests' + _self.properties.sFormRand).show();
                    $('#booking_date_start-wrapper' + _self.properties.sFormRand).show();
                    $('#booking_date_end-wrapper' + _self.properties.sFormRand).show();
                    $('#booking_guests-wrapper' + _self.properties.sFormRand).show();
                    break;
                case 'sold':
                    $('#with_photo_box' + _self.properties.sFormRand).show();
                    $('#booking_date_start' + _self.properties.sFormRand).hide();
                    $('#booking_date_end' + _self.properties.sFormRand).hide();
                    $('#booking_date_start-wrapper' + _self.properties.sFormRand).hide();
                    $('#booking_date_end-wrapper' + _self.properties.sFormRand).hide();
                    $('#booking_guests-wrapper' + _self.properties.sFormRand).hide();
                    $('#date_start' + _self.properties.sFormRand).val('');
                    $('#alt_date_start' + _self.properties.sFormRand).val('');
                    $('#date_end' + _self.properties.sFormRand).val('');
                    $('#alt_date_end' + _self.properties.sFormRand).val('');
                    $('#booking_guests' + _self.properties.sFormRand).hide().find('select').val('');
                    break;
            }
        });

    };

    var bindSaveSearch = function () {
        $('#' + _self.properties.saveBlockId).bind('submit', function () {
            _self.save_search();
            return false;
        });
        $('.' + _self.properties.saveButtonClass).bind('click', function () {
            _self.save_search();
            return false;
        });
        $('.' + _self.properties.saveSearchDeleteItem).bind('click', function () {
            var ajax_url = $(this).attr('href').replace(_self.properties.deleteSearchUrl, _self.properties.deleteSearchAjaxUrl);
            if (ajax_url !== $(this).attr('href')) {
                _self.delete_filter(ajax_url);
            }
            return false;
        });
        $('.' + _self.properties.saveSearchDeleteFilterItem).bind('click', function () {
            var ajax_url = $(this).attr('href').replace(_self.properties.deleteFilterUrl, _self.properties.deleteFilterAjaxUrl);
            if (ajax_url !== $(this).attr('href')) {
                _self.delete_search(ajax_url);
            }
            return false;
        });

        // TODO:del
        _self.properties.tIds = [];
        if (_self.properties.tIds.length) {
            for (var index in _self.properties.tIds) {
                var id = _self.properties.tIds[index];
                $(document).on('click', '#' + id + ' a', function () {
                    var new_url = $(this).attr('href').replace(_self.properties.deleteSearchUrl, _self.properties.deleteSearchAjaxUrl);
                    if (new_url !== $(this).attr('href')) {
                        _self.delete_search(new_url);
                        return false;
                    }

                    new_url = $(this).attr('href').replace(_self.properties.deleteFilterUrl, _self.properties.deleteFilterAjaxUrl);
                    if (new_url !== $(this).attr('href')) {
                        _self.delete_filter(new_url);
                        return false;
                    }

                    return true;
                });
            }
        }
    };

    this.updateSaveSearch = function () {
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.saveSearchUpdateUrl,
            type: 'POST',
            cache: false,
            data: {},
            success: function (data) {
                $('.' + _self.properties.saveSearchBlockClass).html(data);
                $('.' + _self.properties.saveSearchBlockClass).find('.dropdown-toggle').trigger('click');
                bindSaveSearch();
            }
        });
    };

    this.search = function () {
        var operation_type = $('#' + _self.properties.sFromId + ' select[id*=operation_type]').val();
        var send_data = $('#' + _self.properties.sFromId).serialize();

        $.ajax({
            url: _self.properties.siteUrl + _self.properties.viewAjaxUrl + operation_type,
            type: 'POST',
            cache: false,
            data: send_data,
            success: function (data) {
                $('.' + _self.properties.sectionCl).change();
                _self.updateSaveSearch();
            }
        });
    };

    this.refine = function () {
        var operation_type = $('#' + _self.properties.sFromId + ' select:first').val();
        var send_data = $('#' + _self.properties.rFromId).serialize();
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.viewAjaxUrl + operation_type,
            type: 'POST',
            cache: false,
            data: send_data,
            success: function (data) {
                $('.' + _self.properties.sectionCl).change();
            }
        });
    };

    this.runPageScroll = function (offset) {
        offset = offset || 0;
        var top = $('#' + _self.properties.listBlockId + ', #' + _self.properties.mapBlockId).offset().top;
        $(document).scrollTop(top + parseInt(offset));
    };

    this.save_search = function () {
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.saveSearchUrl,
            type: 'GET',
            cache: false,
            dataType: 'json',
            success: function (data) {
                if (data.success) {
                    _self.properties.errorObj.show_error_block(data.success, 'success');
                    $('#' + _self.properties.searchesBlockId).html(data.data);
                    _self.updateSaveSearch();
                } else {
                    _self.properties.errorObj.show_error_block(data.error, 'error');
                }
                return false;
            }
        });
    };

    this.load_extend_form = function (type, category_id) {
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.loadQuickForm,
            type: 'POST',
            cache: false,
            data: {type: type, id_category: category_id},
            dataType: 'html',
            success: function (data) {
                $('#' + _self.properties.quickFormId).find('.ui-slider').empty();
                $('#' + _self.properties.quickFormId).html(data);
                _self.updateSaveSearch();
            }
        });

        $.ajax({
            url: _self.properties.siteUrl + _self.properties.loadAdvancedForm,
            type: 'POST',
            cache: false,
            data: {type: type, id_category: category_id},
            dataType: 'html',
            success: function (data) {
                $('#' + _self.properties.advancedFormId).find('.ui-slider').empty();
                $('#' + _self.properties.advancedFormId).html(data);
            }
        });
    };

    this.delete_search = function (url) {
        $.ajax({
            url: url,
            type: 'GET',
            cache: false,
            dataType: 'json',
            success: function (data) {
                if (data.error) {
                    _self.properties.errorObj.show_error_block(data.error, 'error');
                } else {
                    $('#' + _self.properties.searchesBlockId).html(data.data);
                    _self.properties.errorObj.show_error_block(data.success, 'success');
                    _self.updateSaveSearch();
                }
                return false;
            }
        });
    };

    this.delete_filter = function (url) {
        $.ajax({
            url: url,
            type: 'GET',
            cache: false,
            dataType: 'json',
            success: function (data) {
                if (data.error) {
                    _self.properties.errorObj.show_error_block(data.error, 'error');
                } else {
                    $('#' + _self.properties.filtersBlockId).html(data.data);
                    _self.properties.errorObj.show_error_block(data.success, 'success');
                    $('#m_' + data.type + ' a').trigger('click');
                    _self.updateSaveSearch();
                }
                return false;
            }
        });
    };

    _self.Init(optionArr);
}
