function listingsShare(optionArr) {
    this.properties = {
        siteUrl: '',
        shareBtn: 'share_btn',
        cFormId: 'share_form',
        urlShareForm: 'listings/ajax_share_form/',
        urlSendMail: 'listings/ajax_share_mail/',
        id_close: 'close_btn',
        listingId: 0,
        contentObj: null,
        errorObj: new Errors
    };

    var _self = this;

    this.Init = function (options) {
        _self.properties = $.extend(_self.properties, options);

        if (!_self.properties.contentObj) {
            _self.properties.contentObj = new loadingContent();
        }

        $('#' + _self.properties.shareBtn).bind('click', function () {
            _self.get_form();
            return false;
        }).show();

        $(document).on('submit', '#' + _self.properties.cFormId, function () {
            _self.send_message();
            return false;
        });
    };

    this.get_form = function () {
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.urlShareForm + _self.properties.listingId,
            type: 'GET',
            cache: false,
            success: function (data) {
                _self.properties.contentObj.show_load_block(data);
                $('#' + _self.properties.id_close).unbind().bind('click', function () {
                    _self.clearBox();
                    return false;
                });
            }
        });
        return false;
    };

    this.send_message = function () {
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.urlSendMail + _self.properties.listingId,
            type: 'POST',
            data: $('#' + _self.properties.cFormId).serialize(),
            dataType: 'json',
            cache: false,
            success: function (data) {
                if (typeof (data.error) !== 'undefined' && data.error != '') {
                    _self.properties.errorObj.show_error_block(data.error, 'error');
                } else {
                    _self.properties.errorObj.show_error_block(data.success, 'success');
                    $('#' + _self.properties.cFormId).find('textarea[name="message"]').val('');
                }
            }
        });
        return false;
    };

    this.clearBox = function () {

    };

    _self.Init(optionArr);
}
