<?php

namespace Pg\Modules\Widgets\Controllers;

/**
 * Widgets module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Widgets user side controller
 *
 * @package 	PG_RealEstate
 * @subpackage 	Widgets
 *
 * @category	controllers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Widgets extends \Controller
{

    /**
     * Constructor
     *
     * @return Widgets
     */
    public function __construct()
    {
        parent::__construct();
        $this->load->model('Widgets_model');
    }

    /**
     * Load widget code
     *
     * @param string $widget_gid widget guid
     *
     * @return string
     */
    public function index($widget_gid)
    {
        $this->Widgets_model->set_format_settings('get_content', true);
        $widget = $this->Widgets_model->get_widget_by_gid($widget_gid, $_SERVER['HTTP_REFERER']);
        $this->Widgets_model->set_format_settings('get_content', false);
        if (!$widget['content']) {
            exit;
        }
        $this->view->assign('widget', $widget);
        $this->view->output($this->view->fetch('widget', 'user', 'widgets'));
        $this->view->render();
    }

    /**
     * Load widget code by ajax
     *
     * @param string $widget_gid widget guid
     *
     * @return string
     */
    public function ajax_index($widget_gid)
    {
        $this->Widgets_model->set_format_settings('get_content', true);
        $widget = $this->Widgets_model->get_widget_by_gid($widget_gid);
        $this->Widgets_model->set_format_settings('get_content', false);
        $this->view->assign('widget', $widget);
        $this->view->output($this->view->fetch('ajax_widget', 'user', 'widgets'));
        $this->view->render();
    }

}
