<?php
/*
* This file is part of phpMorphy project
*
* Copyright (c) 2007-2012 Kamaev Vladimir <heromantor@users.sourceforge.net>
*
*     This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
*     This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
*     You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*/
 
// This file is autogenerated at Sun, 05 Dec 2010 19:36:14 +0300, don`t change it!

// consts for Russian language
// part of speech
/**
 * PMY_RP_NOUN "С" part of speech */
define('PMY_RP_NOUN', 0);
/**
 * PMY_RP_ADJ_FULL "П" part of speech */
define('PMY_RP_ADJ_FULL', 1);
/**
 * PMY_RP_VERB "Г" part of speech */
define('PMY_RP_VERB', 2);
/**
 * PMY_RP_PRONOUN "МС" part of speech */
define('PMY_RP_PRONOUN', 3);
/**
 * PMY_RP_PRONOUN_P "МС-П" part of speech */
define('PMY_RP_PRONOUN_P', 4);
/**
 * PMY_RP_PRONOUN_PREDK "МС-ПРЕДК" part of speech */
define('PMY_RP_PRONOUN_PREDK', 5);
/**
 * PMY_RP_NUMERAL "ЧИСЛ" part of speech */
define('PMY_RP_NUMERAL', 6);
/**
 * PMY_RP_NUMERAL_P "ЧИСЛ-П" part of speech */
define('PMY_RP_NUMERAL_P', 7);
/**
 * PMY_RP_ADV "Н" part of speech */
define('PMY_RP_ADV', 8);
/**
 * PMY_RP_PREDK "ПРЕДК" part of speech */
define('PMY_RP_PREDK', 9);
/**
 * PMY_RP_PREP "ПРЕДЛ" part of speech */
define('PMY_RP_PREP', 10);
/**
 * PMY_RP_POSL "ПОСЛ" part of speech */
define('PMY_RP_POSL', 11);
/**
 * PMY_RP_CONJ "СОЮЗ" part of speech */
define('PMY_RP_CONJ', 12);
/**
 * PMY_RP_INTERJ "МЕЖД" part of speech */
define('PMY_RP_INTERJ', 13);
/**
 * PMY_RP_INP "ВВОДН" part of speech */
define('PMY_RP_INP', 14);
/**
 * PMY_RP_PHRASE "ФРАЗ" part of speech */
define('PMY_RP_PHRASE', 15);
/**
 * PMY_RP_PARTICLE "ЧАСТ" part of speech */
define('PMY_RP_PARTICLE', 16);
/**
 * PMY_RP_ADJ_SHORT "КР_ПРИЛ" part of speech */
define('PMY_RP_ADJ_SHORT', 17);
/**
 * PMY_RP_PARTICIPLE "ПРИЧАСТИЕ" part of speech */
define('PMY_RP_PARTICIPLE', 18);
/**
 * PMY_RP_ADVERB_PARTICIPLE "ДЕЕПРИЧАСТИЕ" part of speech */
define('PMY_RP_ADVERB_PARTICIPLE', 19);
/**
 * PMY_RP_PARTICIPLE_SHORT "КР_ПРИЧАСТИЕ" part of speech */
define('PMY_RP_PARTICIPLE_SHORT', 20);
/**
 * PMY_RP_INFINITIVE "ИНФИНИТИВ" part of speech */
define('PMY_RP_INFINITIVE', 21);
/**
 * PMY_RP_EMPTY "" part of speech */
define('PMY_RP_EMPTY', 22);
/**
 * PMY_RP_DELETED "DELETED" part of speech */
define('PMY_RP_DELETED', 255);
    
// grammems
/**
 * PMY_RG_PLURAL "МН" grammem */
define('PMY_RG_PLURAL', 0);
/**
 * PMY_RG_SINGULAR "ЕД" grammem */
define('PMY_RG_SINGULAR', 1);
/**
 * PMY_RG_NOMINATIV "ИМ" grammem */
define('PMY_RG_NOMINATIV', 2);
/**
 * PMY_RG_GENITIV "РД" grammem */
define('PMY_RG_GENITIV', 3);
/**
 * PMY_RG_DATIV "ДТ" grammem */
define('PMY_RG_DATIV', 4);
/**
 * PMY_RG_ACCUSATIV "ВН" grammem */
define('PMY_RG_ACCUSATIV', 5);
/**
 * PMY_RG_INSTRUMENTALIS "ТВ" grammem */
define('PMY_RG_INSTRUMENTALIS', 6);
/**
 * PMY_RG_LOCATIV "ПР" grammem */
define('PMY_RG_LOCATIV', 7);
/**
 * PMY_RG_VOCATIV "ЗВ" grammem */
define('PMY_RG_VOCATIV', 8);
/**
 * PMY_RG_MASCULINUM "МР" grammem */
define('PMY_RG_MASCULINUM', 9);
/**
 * PMY_RG_FEMINUM "ЖР" grammem */
define('PMY_RG_FEMINUM', 10);
/**
 * PMY_RG_NEUTRUM "СР" grammem */
define('PMY_RG_NEUTRUM', 11);
/**
 * PMY_RG_MASC_FEM "МР-ЖР" grammem */
define('PMY_RG_MASC_FEM', 12);
/**
 * PMY_RG_PRESENT_TENSE "НСТ" grammem */
define('PMY_RG_PRESENT_TENSE', 13);
/**
 * PMY_RG_FUTURE_TENSE "БУД" grammem */
define('PMY_RG_FUTURE_TENSE', 14);
/**
 * PMY_RG_PAST_TENSE "ПРШ" grammem */
define('PMY_RG_PAST_TENSE', 15);
/**
 * PMY_RG_FIRST_PERSON "1Л" grammem */
define('PMY_RG_FIRST_PERSON', 16);
/**
 * PMY_RG_SECOND_PERSON "2Л" grammem */
define('PMY_RG_SECOND_PERSON', 17);
/**
 * PMY_RG_THIRD_PERSON "3Л" grammem */
define('PMY_RG_THIRD_PERSON', 18);
/**
 * PMY_RG_IMPERATIVE "ПВЛ" grammem */
define('PMY_RG_IMPERATIVE', 19);
/**
 * PMY_RG_ANIMATIVE "ОД" grammem */
define('PMY_RG_ANIMATIVE', 20);
/**
 * PMY_RG_NON_ANIMATIVE "НО" grammem */
define('PMY_RG_NON_ANIMATIVE', 21);
/**
 * PMY_RG_COMPARATIVE "СРАВН" grammem */
define('PMY_RG_COMPARATIVE', 22);
/**
 * PMY_RG_PERFECTIVE "СВ" grammem */
define('PMY_RG_PERFECTIVE', 23);
/**
 * PMY_RG_NON_PERFECTIVE "НС" grammem */
define('PMY_RG_NON_PERFECTIVE', 24);
/**
 * PMY_RG_NON_TRANSITIVE "НП" grammem */
define('PMY_RG_NON_TRANSITIVE', 25);
/**
 * PMY_RG_TRANSITIVE "ПЕ" grammem */
define('PMY_RG_TRANSITIVE', 26);
/**
 * PMY_RG_ACTIVE_VOICE "ДСТ" grammem */
define('PMY_RG_ACTIVE_VOICE', 27);
/**
 * PMY_RG_PASSIVE_VOICE "СТР" grammem */
define('PMY_RG_PASSIVE_VOICE', 28);
/**
 * PMY_RG_INDECLINABLE "0" grammem */
define('PMY_RG_INDECLINABLE', 29);
/**
 * PMY_RG_INITIALISM "АББР" grammem */
define('PMY_RG_INITIALISM', 30);
/**
 * PMY_RG_PATRONYMIC "ОТЧ" grammem */
define('PMY_RG_PATRONYMIC', 31);
/**
 * PMY_RG_TOPONYM "ЛОК" grammem */
define('PMY_RG_TOPONYM', 32);
/**
 * PMY_RG_ORGANISATION "ОРГ" grammem */
define('PMY_RG_ORGANISATION', 33);
/**
 * PMY_RG_QUALITATIVE "КАЧ" grammem */
define('PMY_RG_QUALITATIVE', 34);
/**
 * PMY_RG_DE_FACTO_SING_TANTUM "ДФСТ" grammem */
define('PMY_RG_DE_FACTO_SING_TANTUM', 35);
/**
 * PMY_RG_INTERROGATIVE "ВОПР" grammem */
define('PMY_RG_INTERROGATIVE', 36);
/**
 * PMY_RG_DEMONSTRATIVE "УКАЗАТ" grammem */
define('PMY_RG_DEMONSTRATIVE', 37);
/**
 * PMY_RG_NAME "ИМЯ" grammem */
define('PMY_RG_NAME', 38);
/**
 * PMY_RG_SUR_NAME "ФАМ" grammem */
define('PMY_RG_SUR_NAME', 39);
/**
 * PMY_RG_IMPERSONAL "БЕЗЛ" grammem */
define('PMY_RG_IMPERSONAL', 40);
/**
 * PMY_RG_SLANG "ЖАРГ" grammem */
define('PMY_RG_SLANG', 41);
/**
 * PMY_RG_MISPRINT "ОПЧ" grammem */
define('PMY_RG_MISPRINT', 42);
/**
 * PMY_RG_COLLOQUIAL "РАЗГ" grammem */
define('PMY_RG_COLLOQUIAL', 43);
/**
 * PMY_RG_POSSESSIVE "ПРИТЯЖ" grammem */
define('PMY_RG_POSSESSIVE', 44);
/**
 * PMY_RG_ARCHAISM "АРХ" grammem */
define('PMY_RG_ARCHAISM', 45);
/**
 * PMY_RG_SECOND_CASE "2" grammem */
define('PMY_RG_SECOND_CASE', 46);
/**
 * PMY_RG_POETRY "ПОЭТ" grammem */
define('PMY_RG_POETRY', 47);
/**
 * PMY_RG_PROFESSION "ПРОФ" grammem */
define('PMY_RG_PROFESSION', 48);
/**
 * PMY_RG_SUPERLATIVE "ПРЕВ" grammem */
define('PMY_RG_SUPERLATIVE', 49);
/**
 * PMY_RG_POSITIVE "ПОЛОЖ" grammem */
define('PMY_RG_POSITIVE', 50);
/**
 * PMY_RG_SHORT "КР" grammem */
define('PMY_RG_SHORT', 51);
/**
 * PMY_RG_INFO "ИНФ" grammem */
define('PMY_RG_INFO', 52);
/**
 * PMY_RG_DEEPR "ДПР" grammem */
define('PMY_RG_DEEPR', 53);
/**
 * PMY_RG_PR "ПРЧ" grammem */
define('PMY_RG_PR', 54);

// meta grammems
function PMY_RG_ALL_NUMBERS() { return array(PMY_RG_PLURAL, PMY_RG_SINGULAR); }
function PMY_RG_ALL_CASES() { return array(PMY_RG_NOMINATIV, PMY_RG_GENITIV, PMY_RG_DATIV, PMY_RG_ACCUSATIV, PMY_RG_INSTRUMENTALIS, PMY_RG_LOCATIV, PMY_RG_VOCATIV); }
function PMY_RG_ALL_GENDERS() { return array(PMY_RG_MASCULINUM, PMY_RG_FEMINUM, PMY_RG_NEUTRUM); }
function PMY_RG_ALL_TIMES() { return array(PMY_RG_PRESENT_TENSE, PMY_RG_FUTURE_TENSE, PMY_RG_PAST_TENSE); }
function PMY_RG_ALL_PERSONS() { return array(PMY_RG_FIRST_PERSON, PMY_RG_SECOND_PERSON, PMY_RG_THIRD_PERSON); }
function PMY_RG_ALL_ANIMATIVE() { return array(PMY_RG_ANIMATIVE, PMY_RG_NON_ANIMATIVE); }

// consts for English language
// part of speech
/**
 * PMY_EP_NOUN "NOUN" part of speech */
define('PMY_EP_NOUN', 0);
/**
 * PMY_EP_ADJ "ADJECTIVE" part of speech */
define('PMY_EP_ADJ', 1);
/**
 * PMY_EP_VERB "VERB" part of speech */
define('PMY_EP_VERB', 2);
/**
 * PMY_EP_VBE "VBE" part of speech */
define('PMY_EP_VBE', 3);
/**
 * PMY_EP_MOD "MOD" part of speech */
define('PMY_EP_MOD', 4);
/**
 * PMY_EP_NUMERAL "NUMERAL" part of speech */
define('PMY_EP_NUMERAL', 5);
/**
 * PMY_EP_CONJ "CONJ" part of speech */
define('PMY_EP_CONJ', 6);
/**
 * PMY_EP_INTERJ "INT" part of speech */
define('PMY_EP_INTERJ', 7);
/**
 * PMY_EP_PREP "PREP" part of speech */
define('PMY_EP_PREP', 8);
/**
 * PMY_EP_PARTICLE "PART" part of speech */
define('PMY_EP_PARTICLE', 9);
/**
 * PMY_EP_ART "ARTICLE" part of speech */
define('PMY_EP_ART', 10);
/**
 * PMY_EP_ADV "ADVERB" part of speech */
define('PMY_EP_ADV', 11);
/**
 * PMY_EP_PN "PN" part of speech */
define('PMY_EP_PN', 12);
/**
 * PMY_EP_ORDNUM "ORDNUM" part of speech */
define('PMY_EP_ORDNUM', 13);
/**
 * PMY_EP_PRON "PRON" part of speech */
define('PMY_EP_PRON', 14);
/**
 * PMY_EP_POSS "POSS" part of speech */
define('PMY_EP_POSS', 15);
/**
 * PMY_EP_PN_ADJ "PN_ADJ" part of speech */
define('PMY_EP_PN_ADJ', 16);
/**
 * PMY_EP_EMPTY "" part of speech */
define('PMY_EP_EMPTY', 17);
/**
 * PMY_EP_DELETED "DELETED" part of speech */
define('PMY_EP_DELETED', 255);
    
// grammems
/**
 * PMY_EG_SINGULAR "SG" grammem */
define('PMY_EG_SINGULAR', 0);
/**
 * PMY_EG_PLURAL "PL" grammem */
define('PMY_EG_PLURAL', 1);
/**
 * PMY_EG_MASCULINUM "M" grammem */
define('PMY_EG_MASCULINUM', 2);
/**
 * PMY_EG_FEMINUM "F" grammem */
define('PMY_EG_FEMINUM', 3);
/**
 * PMY_EG_ANIMATIVE "ANIM" grammem */
define('PMY_EG_ANIMATIVE', 4);
/**
 * PMY_EG_PERFECTIVE "PERF" grammem */
define('PMY_EG_PERFECTIVE', 5);
/**
 * PMY_EG_NOMINATIVE "NOM" grammem */
define('PMY_EG_NOMINATIVE', 6);
/**
 * PMY_EG_OBJECT_CASE "OBJ" grammem */
define('PMY_EG_OBJECT_CASE', 7);
/**
 * PMY_EG_NARRATIVE "NARR" grammem */
define('PMY_EG_NARRATIVE', 8);
/**
 * PMY_EG_GEOGRAPHICS "GEO" grammem */
define('PMY_EG_GEOGRAPHICS', 9);
/**
 * PMY_EG_PROPER "PROP" grammem */
define('PMY_EG_PROPER', 10);
/**
 * PMY_EG_PERSONAL_PRONOUN "PERS" grammem */
define('PMY_EG_PERSONAL_PRONOUN', 11);
/**
 * PMY_EG_POSSESSIVE "POSS" grammem */
define('PMY_EG_POSSESSIVE', 12);
/**
 * PMY_EG_PREDICATIVE "PRED" grammem */
define('PMY_EG_PREDICATIVE', 13);
/**
 * PMY_EG_UNCOUNTABLE "UNCOUNT" grammem */
define('PMY_EG_UNCOUNTABLE', 14);
/**
 * PMY_EG_REFLEXIVE_PRONOUN "REF" grammem */
define('PMY_EG_REFLEXIVE_PRONOUN', 15);
/**
 * PMY_EG_DEMONSTRATIVE_PRONOUN "DEM" grammem */
define('PMY_EG_DEMONSTRATIVE_PRONOUN', 16);
/**
 * PMY_EG_MASS "MASS" grammem */
define('PMY_EG_MASS', 17);
/**
 * PMY_EG_COMPARATIV "COMP" grammem */
define('PMY_EG_COMPARATIV', 18);
/**
 * PMY_EG_SUPREMUM "SUP" grammem */
define('PMY_EG_SUPREMUM', 19);
/**
 * PMY_EG_FIRST_PERSON "1" grammem */
define('PMY_EG_FIRST_PERSON', 20);
/**
 * PMY_EG_SECOND_PERSON "2" grammem */
define('PMY_EG_SECOND_PERSON', 21);
/**
 * PMY_EG_THIRD_PERSON "3" grammem */
define('PMY_EG_THIRD_PERSON', 22);
/**
 * PMY_EG_PRESENT_INDEF "PRSA" grammem */
define('PMY_EG_PRESENT_INDEF', 23);
/**
 * PMY_EG_INFINITIVE "INF" grammem */
define('PMY_EG_INFINITIVE', 24);
/**
 * PMY_EG_PAST_INDEF "PASA" grammem */
define('PMY_EG_PAST_INDEF', 25);
/**
 * PMY_EG_PAST_PARTICIPLE "PP" grammem */
define('PMY_EG_PAST_PARTICIPLE', 26);
/**
 * PMY_EG_GERUND "ING" grammem */
define('PMY_EG_GERUND', 27);
/**
 * PMY_EG_FUTURUM "FUT" grammem */
define('PMY_EG_FUTURUM', 28);
/**
 * PMY_EG_CONDITIONAL "IF" grammem */
define('PMY_EG_CONDITIONAL', 29);
/**
 * PMY_EG_APOSTROPHE_S "PLSQ" grammem */
define('PMY_EG_APOSTROPHE_S', 30);
/**
 * PMY_EG_APOSTROPHE "PLSGS" grammem */
define('PMY_EG_APOSTROPHE', 31);
/**
 * PMY_EG_NAMES "NAME" grammem */
define('PMY_EG_NAMES', 32);
/**
 * PMY_EG_ORGANISATION "ORG" grammem */
define('PMY_EG_ORGANISATION', 33);

// meta grammems

// consts for German language
// part of speech
/**
 * PMY_GP_ART "ART" part of speech */
define('PMY_GP_ART', 0);
/**
 * PMY_GP_ADJ "ADJ" part of speech */
define('PMY_GP_ADJ', 1);
/**
 * PMY_GP_ADV "ADV" part of speech */
define('PMY_GP_ADV', 2);
/**
 * PMY_GP_EIG "EIG" part of speech */
define('PMY_GP_EIG', 3);
/**
 * PMY_GP_SUB "SUB" part of speech */
define('PMY_GP_SUB', 4);
/**
 * PMY_GP_VER "VER" part of speech */
define('PMY_GP_VER', 5);
/**
 * PMY_GP_P_A1 "PA1" part of speech */
define('PMY_GP_P_A1', 6);
/**
 * PMY_GP_P_A2 "PA2" part of speech */
define('PMY_GP_P_A2', 7);
/**
 * PMY_GP_PRONOMEN "PRO" part of speech */
define('PMY_GP_PRONOMEN', 8);
/**
 * PMY_GP_PRP "PRP" part of speech */
define('PMY_GP_PRP', 9);
/**
 * PMY_GP_KON "KON" part of speech */
define('PMY_GP_KON', 10);
/**
 * PMY_GP_NEG "NEG" part of speech */
define('PMY_GP_NEG', 11);
/**
 * PMY_GP_INJ "INJ" part of speech */
define('PMY_GP_INJ', 12);
/**
 * PMY_GP_ZAL "ZAL" part of speech */
define('PMY_GP_ZAL', 13);
/**
 * PMY_GP_ZUS "ZUS" part of speech */
define('PMY_GP_ZUS', 14);
/**
 * PMY_GP_PRO_BEG "PROBEG" part of speech */
define('PMY_GP_PRO_BEG', 15);
/**
 * PMY_GP_ZU_INFINITIV "INF" part of speech */
define('PMY_GP_ZU_INFINITIV', 16);
/**
 * PMY_GP_EMPTY "" part of speech */
define('PMY_GP_EMPTY', 17);
/**
 * PMY_GP_DELETED "DELETED" part of speech */
define('PMY_GP_DELETED', 255);
    
// grammems
/**
 * PMY_GG_NOA_UNK "NOA" grammem */
define('PMY_GG_NOA_UNK', 0);
/**
 * PMY_GG_PREDIK_BENUTZ "PRD" grammem */
define('PMY_GG_PREDIK_BENUTZ', 1);
/**
 * PMY_GG_PRO_UNK "PRO" grammem */
define('PMY_GG_PRO_UNK', 2);
/**
 * PMY_GG_TMP_UNK "TMP" grammem */
define('PMY_GG_TMP_UNK', 3);
/**
 * PMY_GG_NAC "NAC" grammem */
define('PMY_GG_NAC', 4);
/**
 * PMY_GG_MOU "MOU" grammem */
define('PMY_GG_MOU', 5);
/**
 * PMY_GG_COU "COU" grammem */
define('PMY_GG_COU', 6);
/**
 * PMY_GG_GEO "GEO" grammem */
define('PMY_GG_GEO', 7);
/**
 * PMY_GG_WASSER "WAT" grammem */
define('PMY_GG_WASSER', 8);
/**
 * PMY_GG_GEB "GEB" grammem */
define('PMY_GG_GEB', 9);
/**
 * PMY_GG_STD "STD" grammem */
define('PMY_GG_STD', 10);
/**
 * PMY_GG_LOK "LOK" grammem */
define('PMY_GG_LOK', 11);
/**
 * PMY_GG_VOR "VOR" grammem */
define('PMY_GG_VOR', 12);
/**
 * PMY_GG_SICH_ACC "SICH-AKK" grammem */
define('PMY_GG_SICH_ACC', 13);
/**
 * PMY_GG_SICH_DAT "SICH-DAT" grammem */
define('PMY_GG_SICH_DAT', 14);
/**
 * PMY_GG_SCHWACH "SFT" grammem */
define('PMY_GG_SCHWACH', 15);
/**
 * PMY_GG_NICHT_SCHWACH "NON" grammem */
define('PMY_GG_NICHT_SCHWACH', 16);
/**
 * PMY_GG_MODAL "MOD" grammem */
define('PMY_GG_MODAL', 17);
/**
 * PMY_GG_AUXILIAR "AUX" grammem */
define('PMY_GG_AUXILIAR', 18);
/**
 * PMY_GG_KONJ1 "KJ1" grammem */
define('PMY_GG_KONJ1', 19);
/**
 * PMY_GG_KONJ2 "KJ2" grammem */
define('PMY_GG_KONJ2', 20);
/**
 * PMY_GG_PARTIZIP1 "PA1" grammem */
define('PMY_GG_PARTIZIP1', 21);
/**
 * PMY_GG_PARTIZIP2 "PA2" grammem */
define('PMY_GG_PARTIZIP2', 22);
/**
 * PMY_GG_ZU_VERB_FORM "EIZ" grammem */
define('PMY_GG_ZU_VERB_FORM', 23);
/**
 * PMY_GG_IMPERATIV "IMP" grammem */
define('PMY_GG_IMPERATIV', 24);
/**
 * PMY_GG_PRAETERITUM "PRT" grammem */
define('PMY_GG_PRAETERITUM', 25);
/**
 * PMY_GG_PRASENS "PRAE" grammem */
define('PMY_GG_PRASENS', 26);
/**
 * PMY_GG_GRUNDFORM "GRU" grammem */
define('PMY_GG_GRUNDFORM', 27);
/**
 * PMY_GG_KOMPARATIV "KOM" grammem */
define('PMY_GG_KOMPARATIV', 28);
/**
 * PMY_GG_SUPERLATIV "SUP" grammem */
define('PMY_GG_SUPERLATIV', 29);
/**
 * PMY_GG_PROPORTIONAL_KONJUNKTION "PRI" grammem */
define('PMY_GG_PROPORTIONAL_KONJUNKTION', 30);
/**
 * PMY_GG_INFINITIV "INF" grammem */
define('PMY_GG_INFINITIV', 31);
/**
 * PMY_GG_VERGLEICHS_KONJUNKTION "VGL" grammem */
define('PMY_GG_VERGLEICHS_KONJUNKTION', 32);
/**
 * PMY_GG_NEBENORDNENDE "NEB" grammem */
define('PMY_GG_NEBENORDNENDE', 33);
/**
 * PMY_GG_UNTERORDNENDE "UNT" grammem */
define('PMY_GG_UNTERORDNENDE', 34);
/**
 * PMY_GG_PERSONAL "PER" grammem */
define('PMY_GG_PERSONAL', 35);
/**
 * PMY_GG_DEMONSTRATIV "DEM" grammem */
define('PMY_GG_DEMONSTRATIV', 36);
/**
 * PMY_GG_INTERROGATIV "INR" grammem */
define('PMY_GG_INTERROGATIV', 37);
/**
 * PMY_GG_POSSESSIV "POS" grammem */
define('PMY_GG_POSSESSIV', 38);
/**
 * PMY_GG_REFLEXIV "REF" grammem */
define('PMY_GG_REFLEXIV', 39);
/**
 * PMY_GG_RIN_PRONOMEN "RIN" grammem */
define('PMY_GG_RIN_PRONOMEN', 40);
/**
 * PMY_GG_ALG_PRONOMEN "ALG" grammem */
define('PMY_GG_ALG_PRONOMEN', 41);
/**
 * PMY_GG_ADJEKTIVE_OHNE_ARTIKEL "SOL" grammem */
define('PMY_GG_ADJEKTIVE_OHNE_ARTIKEL', 42);
/**
 * PMY_GG_ADJEKTIVE_MIT_UNBESTIMMTE "IND" grammem */
define('PMY_GG_ADJEKTIVE_MIT_UNBESTIMMTE', 43);
/**
 * PMY_GG_ADJEKTIVE_MIT_BESTIMMTE "DEF" grammem */
define('PMY_GG_ADJEKTIVE_MIT_BESTIMMTE', 44);
/**
 * PMY_GG_ERSTE_PERSON "1" grammem */
define('PMY_GG_ERSTE_PERSON', 45);
/**
 * PMY_GG_ZWEITE_PERSON "2" grammem */
define('PMY_GG_ZWEITE_PERSON', 46);
/**
 * PMY_GG_DRITTE_PERSON "3" grammem */
define('PMY_GG_DRITTE_PERSON', 47);
/**
 * PMY_GG_FEMININ "FEM" grammem */
define('PMY_GG_FEMININ', 48);
/**
 * PMY_GG_MASKULIN "MAS" grammem */
define('PMY_GG_MASKULIN', 49);
/**
 * PMY_GG_NEUTRUM "NEU" grammem */
define('PMY_GG_NEUTRUM', 50);
/**
 * PMY_GG_PLURAL "PLU" grammem */
define('PMY_GG_PLURAL', 51);
/**
 * PMY_GG_SINGULAR "SIN" grammem */
define('PMY_GG_SINGULAR', 52);
/**
 * PMY_GG_NOMINATIV "NOM" grammem */
define('PMY_GG_NOMINATIV', 53);
/**
 * PMY_GG_GENITIV "GEN" grammem */
define('PMY_GG_GENITIV', 54);
/**
 * PMY_GG_DATIV "DAT" grammem */
define('PMY_GG_DATIV', 55);
/**
 * PMY_GG_AKKUSATIV "AKK" grammem */
define('PMY_GG_AKKUSATIV', 56);
/**
 * PMY_GG_ABBREVIATION "ABBR" grammem */
define('PMY_GG_ABBREVIATION', 57);
/**
 * PMY_GG_EINWOHNER "EW" grammem */
define('PMY_GG_EINWOHNER', 58);
/**
 * PMY_GG_TRANSITIV "TRANS" grammem */
define('PMY_GG_TRANSITIV', 59);
/**
 * PMY_GG_INTRANSITIV "INTRA" grammem */
define('PMY_GG_INTRANSITIV', 60);
/**
 * PMY_GG_IMPERSONAL "IMPER" grammem */
define('PMY_GG_IMPERSONAL', 61);

// meta grammems

// consts for Special language
// part of speech
/**
 * PMY_SPECIALP_DELETED "DELETED" part of speech */
define('PMY_SPECIALP_DELETED', 255);
    
// grammems

// meta grammems

// consts for Unknown language
// part of speech
/**
 * PMY_UP_UNKNOWN "UNKNOWN" part of speech */
define('PMY_UP_UNKNOWN', 0);
/**
 * PMY_UP_DELETED "DELETED" part of speech */
define('PMY_UP_DELETED', 255);
    
// grammems
/**
 * PMY_UG_UNKNOWN "" grammem */
define('PMY_UG_UNKNOWN', 0);

// meta grammems

